// 12_a_cs_neeshka
/*
	Handles Neeshka's intro scene
*/
// JYL 11/19/05
// DBR - animations for guards harassing Neeshka
// DBR 7/17/06 - removed any eplicit attack commands, except at the very end.	

#include "ginc_group"
#include "nw_i0_generic"
	
void StopWolves()
{
/*	object oWolf;
	object oChicken = GetObjectByTag("12_wolf_chicken");
	object oKhelgar = GetObjectByTag("khelgar");
	int nLoop;
	string sTag = "12_fort_wolf";
		
	AssignCommand(oKhelgar, ClearAllActions(TRUE));
	
	for (nLoop = 1; nLoop <= 20; nLoop++)
	{
		object oWolf = GetObjectByTag(sTag, nLoop);
		ChangeFaction(oWolf, oChicken);
		AssignCommand(oWolf, ClearAllActions(TRUE));
	}*/
}
		
void StartWolves()
{
/*	object oWolf;
	int nLoop;
	string sTag = "12_fort_wolf";
		
	for (nLoop = 1; nLoop <= 20; nLoop++)
	{
		object oWolf = GetObjectByTag(sTag, nLoop);
		ChangeToStandardFaction(oWolf, STANDARD_FACTION_HOSTILE);
		AssignCommand(oWolf, DetermineCombatRound());
	}*/
}

void main (int nDialogNode)
{
	object oNeeshka = GetObjectByTag("neeshka");
	object oKhelgar = GetObjectByTag("khelgar");
	object oPC = GetFirstPC();
	object oNBandit;
	int i;
	switch (nDialogNode)
	{
		case 10: // Neeshka Immortal
		{
			SetImmortal(oNeeshka, TRUE);
		}
		break;
		case 20: // Turn off Neeshka Immortal
		{
			SetImmortal(oNeeshka, FALSE);
		}
		break;
		case 50:
		{
			StopWolves();
			//Make Neeshka Chaotic Neutral rather than True Neutral
			AdjustAlignment(oNeeshka, ALIGNMENT_CHAOTIC, 50);
		}
		break;
		case 100: // Bandit takes a swipe at Neeshka. She dodges.
		{
			location lPC = GetLocation(GetWaypointByTag("1209_wp_pc_jump1"));
			location lKhelgar = GetLocation(GetWaypointByTag("1209_wp_khel_jump1"));

			SetLocalInt(GetModule(), "StopNeeshkaAnims", 1);
			oNBandit = GetObjectByTag("NBandit1");

			AssignCommand(oPC, ClearAllActions(TRUE));
			AssignCommand(oPC, ActionJumpToLocation(lPC));

			AssignCommand(oKhelgar, ClearAllActions(TRUE));
			AssignCommand(oKhelgar, ActionJumpToLocation(lKhelgar));

			PlayCustomAnimation(oNBandit,"*1attack01",0);
			PlayCustomAnimation(oNeeshka, "*dodge01", 0);
			//AssignCommand(oNBandit, ClearAllActions(TRUE));
			//AssignCommand(oNBandit, ActionAttack(oNeeshka));
			//AssignCommand(oNBandit, ClearAllActions(TRUE));

			SetImmortal(oNeeshka, TRUE);
			AssignCommand(oNeeshka, ClearAllActions(TRUE));
			AssignCommand(oNeeshka, ActionPlayAnimation(ANIMATION_FIREFORGET_DODGE_SIDE));

			SetCombatOverrides( GetObjectByTag("NBandit1"), OBJECT_INVALID, -1,-1, OVERRIDE_ATTACK_RESULT_MISS, 0, 0, TRUE, TRUE, TRUE, TRUE );
			SetCombatOverrides( GetObjectByTag("NBandit2"), OBJECT_INVALID, -1,-1, OVERRIDE_ATTACK_RESULT_MISS, 0, 0, TRUE, TRUE, TRUE, TRUE );
			SetCombatOverrides( GetObjectByTag("NBandit3"), OBJECT_INVALID, -1,-1, OVERRIDE_ATTACK_RESULT_MISS, 0, 0, TRUE, TRUE, TRUE, TRUE );
			SetCombatOverrides( GetObjectByTag("NBandit4"), OBJECT_INVALID, -1,-1, OVERRIDE_ATTACK_RESULT_MISS, 0, 0, TRUE, TRUE, TRUE, TRUE );
		}
		break;
		case 200: //Bandit plays some animation TBD
		{
			oNBandit = GetObjectByTag("NBandit1");

			AssignCommand(oNBandit, ClearAllActions(TRUE));
			AssignCommand(oNBandit, ActionPlayAnimation(ANIMATION_FIREFORGET_TAUNT));
		}
		break;
		case 250: //Bandits fire off animations
		{			
			for (i=1;i<=4;i++)
			{
				AssignCommand(GetObjectByTag("NBandit"+IntToString(i)),ClearAllActions(TRUE));
				switch (Random(4))
				{
					case 0:
					AssignCommand(GetObjectByTag("NBandit"+IntToString(i)),DelayCommand(IntToFloat(Random(100))/100.0f, ActionPlayAnimation(ANIMATION_FIREFORGET_TAUNT)));
					AssignCommand(oNeeshka,PlayAnimation(ANIMATION_FIREFORGET_SEARCH));
					break;
					case 1:
					AssignCommand(GetObjectByTag("NBandit"+IntToString(i)),DelayCommand(IntToFloat(Random(100))/100.0f, ActionPlayAnimation(ANIMATION_FIREFORGET_INTIMIDATE)));
					AssignCommand(oNeeshka,PlayAnimation(ANIMATION_FIREFORGET_SEARCH));
					break;
					case 2:
						PlayCustomAnimation(GetObjectByTag("Bandit"+IntToString(i)),"*1attack01",0);
						PlayCustomAnimation(oNeeshka, "*dodge01", 0);
					//AssignCommand(GetObjectByTag("NBandit"+IntToString(i)),ActionAttack(oNeeshka));
					//AssignCommand(GetObjectByTag("NBandit"+IntToString(i)),DelayCommand(9.0f,ClearAllActions(TRUE)));
					break;
					default:
					AssignCommand(oNeeshka,PlayAnimation(ANIMATION_FIREFORGET_SEARCH));
					AssignCommand(GetObjectByTag("NBandit"+IntToString(i)),DelayCommand(IntToFloat(Random(100))/100.0f, ActionPlayAnimation(ANIMATION_FIREFORGET_CHUCKLE)));
					break;
				}				
			}
		}break;
		case 300: //Bandit is angry. Play Animation.
		{
			oNBandit = GetObjectByTag("NBandit1");

			AssignCommand(oNBandit, ClearAllActions(TRUE));
			AssignCommand(oNBandit, ActionPlayAnimation(ANIMATION_FIREFORGET_TAUNT));
		}
		break;
		case 400: // Player approaches. Bandits turn to look.
		{
			location lPC = GetLocation(GetWaypointByTag("PlayerWalk_WP"));
			location lKhelgar = GetLocation(GetWaypointByTag("KhelgarWalk_WP"));
			object oFace = GetObjectByTag("PlayerWalk_WP");
			vector vFace = GetPosition(oFace);
			int nLoop;

			AssignCommand(oPC, ClearAllActions(TRUE));
			AssignCommand(oPC, ActionMoveToLocation(lPC));

			AssignCommand(oKhelgar, ClearAllActions(TRUE));
			AssignCommand(oKhelgar, ActionMoveToLocation(lKhelgar));

			for (nLoop =1; nLoop <= 4; nLoop++)
			{
				oNBandit = GetObjectByTag("NBandit" + IntToString(nLoop));

				AssignCommand(oNBandit, ClearAllActions(TRUE));
				AssignCommand(oNBandit, SetFacingPoint(vFace, FALSE));
			}
		}
		break;
		case 500: // Everyone fight
		{
			SetCommandable(TRUE, oPC);
			SetCommandable(TRUE, oKhelgar);
			
			string sGroupName = "Bandits";
			object oNBandit;
			int i;

			StartWolves();
			ResetGroup(sGroupName);

			for (i = 1; i<=4; i++)
			{
				object oNBandit = GetObjectByTag("NBandit" + IntToString(i));
				//AddToGroup(sGroupName, oNBandit);
				GroupAddMember(sGroupName, oNBandit);
				ChangeToStandardFaction(oNBandit, STANDARD_FACTION_HOSTILE);
				if (i<=2)
					AssignCommand(oNBandit, ActionAttack(oPC));
				else
					AssignCommand(oNBandit, ActionAttack(oKhelgar));
				ClearCombatOverrides(oNBandit);
			}
			//GroupOnDeathBeginConversation(sGroupName, "neeshka", "12_cs_neeshka");
			GroupOnDeathExecuteCustomScript(sGroupName, "12_a_neeshka_fix");	

			ChangeToStandardFaction(oNeeshka, STANDARD_FACTION_DEFENDER);
			AssignCommand(oNeeshka, ClearAllActions(TRUE));
			AssignCommand(oNeeshka, DetermineCombatRound());
		
			SetLocalInt(GetModule(), "NeeshkaCutscene", 1);
		
		}
		break;
	}
}